/*
###############################################################################
#
# This file can be distributed and modified freely, as long as this original
# header is not modified.
#
# Author:         Nicolas Hatier <email removed for anti-spam purpose,
#                                 Available on http://www.niversoft.com>
# Organization:   Niversoft ides logicielles / software ideas.
# Date:           August 2003
#
# This code is provided AS IS, without any certification that it will even compile.
#
###############################################################################
*/

#include <stdio.h>
#include <string.h>

void main()
{
   char buffer[1024];

   // for more preformance this code but it should be modified to be multithreaded
   while (gets(buffer) != NULL)
   {
      char * line[3];
      char lineID[10];

      line[0] = strtok(buffer, " ");
      line[1] = strtok(NULL, " ");
      line[2] = strtok(NULL, " ");
      strcpy(lineID, line[0]);


      if (!line[1]) // Error in command
      {
         printf("%s FAILURE\n", lineID);
      }
      else if (!strnicmp(line[1], "intf ", 5)) // Interface version
      {
         printf("%s INTF 3\n", lineID);
      }
      else if (!strnicmp(line[1], "key", 3))  // Undocumented
      {
         printf("%s OK\n", lineID);
      }
      else if (!strnicmp(line[1], "quit", 4)) // Prepare to quit
      {
         printf("%s OK\n", lineID);
      }
      else if (strnicmp(line[1], "file ", 5)) // Other unsupported commands
      {
         printf("%s FAILURE\n", lineID);
      }
      else // This is a FILE command
      {
         bool Reject = false;
         if (FILE * fil = fopen(line[2], "r"))
         {
            // Do Something With The File Contents
            // Set Reject to true to reject the msg
            fclose(fil);
         }
         else
         {
            printf("* File Not Found %s\n", line[2]); // This is not an error, probably a problem with the filter, but we log it anyway
         }
         if (Reject)
            printf("%s OK\n", lineID);
         else
            printf("%s REJECTED \"Rejected by external filter\"\n", lineID);

         // You can also use
         // printf("%s ADDHEADER \"Header to add: Header value\"\n", lineID);
         // printf("%s DISCARD\n", lineID);
         // printf("%s REJECTED  \"Postponed by external filter\"\n", lineID);
      }
      fflush(stdout);
   }

   return;
}
