#!/bin/perl

###############################################################################
#
# This file can be distributed and modified freely, as long as this original
# header is not modified.
#
# Author:         Nicolas Hatier <email removed for anti-spam purpose,
#                                  Available on http://www.niversoft.com>
# Organization:   Niversoft ides logicielles / software ideas.
# Date:           August 2003
#
# This code is provided AS IS, without any certification that it will even run
#
###############################################################################

my $CustomHeader = "X-NHContentFiltered: yes";

# This filter is implemented as a Content-Filtering script for Communicate Pro
# Presence of the new headers is automatically verified by this script to avoid
# infinite message loops in the server, but you can verify it in a Rule before
# passing the message to this script. The Rule to add is:
#     Data:    Header Field    is not    [the contents of $CustomHeader above]
#     Action:  ExternalFilter [the name of the external filter that corresponds
#                              to this script in the Helpers section]
#
# Another rule can check the presence of the custom headers you'll add
# to the message, and process the message in the good mailbox.

sub Log
{
   print "* $_[0]\n";
}

$| = 1;

Log "Content-Filter is running";
Log "";

mkdir "Submitted" if (!-d "Submitted");

while (<>)
{
   my @line = split(/ /, $_);
  chomp($line[0]);

   # Verifying the command send by the server.
   print "$line[0] OK\n"      and next if ($line[1] =~ /^quit$/i);
   print "$line[0] INTF 3\n"  and next if ($line[1] =~ /^intf$/i);
   print "$line[0] OK\n"      and next if ($line[1] =~ /^key$/i);
	print "$line[0] FAILURE\n" and next if ($line[1] !~ /^file$/i); # other unsupported commands

   Log "Content-Filter process starting";
   Log "";

   $line[2] =~ s|\\|/|g; # Getting the filepath
   chomp($line[2]);

   if (!open(MSG, $line[2]))
   {
      Log "File Not Found $line[2]";
      print "$line[0] OK\n";
   }
   else
   {
      my ($sender, @recipients);

      # This while loop is taken from notifyRecipients.pl that comes in
      # the CGPMcAfee package
      # This extracts the envelope information
      while(1)
      {
         $line = <MSG>;
         chomp($line);
         last if($line eq '');
         if($line =~ /^(\w).+<(.+)>/)
         {
            if($1 eq 'P')
            {
               $sender = $2;
            }
            else
            {
               push @recipients, $2;
            }
         }
      }

      # $EntireMessage now contains the entire message with headers
      my $EntireMessage = join("", <MSG>);
      close MSG;

      # This will speed up the process if you use a lot of regular
      # expressions. You can comment it if you don't use more than 3 RE.
      study $EntireMessage;


      # Does this message have already been filtered by this script?
      if ($EntireMessage !~ /$CustomHeader/i)
      {
         Log "Message length: ".(length $line)." chars";


         # TODO: Here you should verify what you want in the message


         # TODO: Add your conditions to the "if"
         if (1) # if it is needed to add headers
         {
            #####     #USE THAT PART ONLY IF YOU HAVE TO MODIFY THE CONTENTS OF THE MESSAGE
            #####
            #####   Log "Need to add things to message : Composing new message\n";
            #####
            #####   my $alertFileName.="Submitted/A".time().int(rand(10000));
            #####   open(SUBM,">$alertFileName.tmp");
            #####   print SUBM "Return-Path: $sender\n";
            #####   print SUBM "Envelope-To: ". join(", ", @recipients)."\n";
            #####
            #####
            #####   # TODO: Add Here your headers
            #####   # print SUBM "X-CustomHeader: CustomValue\n";
            #####
            #####
            #####   # Then we output all the message
            #####   print SUBM "$CustomHeader\n";
            #####   print SUBM $EntireMessage;
            #####   # ADD YOUR THINGS HERE
            #####   close SUBM;
            #####
            #####   # We rename the file so the server will process it
            #####   rename("$alertFileName.tmp","$alertFileName.sub");
            #####
            #####   # We tell the server to discard the original message
            #####   print "$line[0] DISCARD\n";
            #####
            #####   # STOP HERE

            print "$line[0] ADDHEADER ".
                  "X-CustomHeader: CustomValue\e".
                  "X-CustomHeader2: CustomValue2\e".
                   "\n";
         }
         else
         {
            # No modification needed. The message can continue.
            print "$line[0] OK\n";
         }
      }
      else
      {
         # No modification needed. The message can continue.
         print "$line[0] OK\n";
      }
   }

   # Just to ensure that STDOUT is correctly flushed and that the
   # server understands our replies.
   open STDOUT, ">&STDOUT";
}


